xquery version "3.1";

module namespace docx="http://teipublisher.com/docx2tei";

import module namespace xmlcalabash="http://exist-db.org/xquery/xproc/xmlcalabash" at "java:org.exist.xquery.xproc.xmlcalabash.XProcXmlCalabashModule";

declare variable $docx:ROOT := repo:get-root() || "/tei-publisher-docx";

declare variable $docx:WORKING_DIR := system:get-exist-home() || "/webapp";

declare function docx:to-tei($path as xs:string) {
    let $xproc := doc("xmldb:" || $docx:ROOT || "/docx2tei/a9s/common/xpl/docx2tei.xpl")
    let $options := (
        <option name="status-dir-uri" value="file:{$docx:WORKING_DIR}"/>,
        <option name="debug-dir-uri" value="file:{$docx:WORKING_DIR}"/>,
        <option name="docxfile" value="xmldb:{$path}"/>,
        <config>xmldb:{$docx:ROOT}/docx2tei/calabash/extensions/transpect/transpect-config.xml</config>,
        <catalog>xmldb:{$docx:ROOT}/docx2tei/calabash/xmlcatalog/catalog.xml</catalog>
    )
    let $output := xmlcalabash:process($xproc, $options)
    return
        parse-xml($output?tei)
};