# transpect docx2tei

XProc conversion pipeline to run in eXist.

## eXist

### Installation

* Download version 0.10 of [XML Calabash XProc Module for eXist-db XQuery](https://s3-eu-west-1.amazonaws.com/uploads-eu.hipchat.com/300223/3427157/uaKEsthxqtqz3Mt/xquery-xproc-xmlcalabash-module-0.10-SNAPSHOT.xar) or compile from [source](https://github.com/eXist-db/xquery-xproc-xmlcalabash-module).

* Uninstall existing XProc plugins via eXist package manager 

* Install XAR file via eXist package manager

* copy docx2tei directory into $EXIST_HOME

* copy `calabash/extensions/transpect/unzip-extension/jar/UnZip.jar` into `$EXIST_HOME/lib/user`


### Run pipeline

```
xquery version "3.1";

import module namespace xmlcalabash="http://exist-db.org/xquery/xproc/xmlcalabash" at "java:org.exist.xquery.xproc.xmlcalabash.XProcXmlCalabashModule";

let $xproc := doc("file:/C:/existdb/docx2hub-frontend/xpl/docx2tei.xpl")

return xmlcalabash:process(
        $xproc,(
                <option name="docx" value="KdS_BS_101_101_hurz.docx"/>,
                <config>file:/C:/existdb/docx2tei/calabash/extensions/transpect/transpect-config.xml</config>,
                <catalog>file:/C:/existdb/docx2tei/calabash/xmlcatalog/catalog.xml</catalog>
        )
)
```


## Shell Script

```
$ ./calabash/calabash.sh -i conf/transpect-conf.xml a9s/common/xpl/docx2tei.xpl docxfile={URI to DOCX file}
```
