<p:declare-step 
  xmlns:p="http://www.w3.org/ns/xproc"
  xmlns:c="http://www.w3.org/ns/xproc-step"
  xmlns:docx2hub="http://transpect.io/docx2hub"
  xmlns:hub2htm="http://transpect.io/hub2htm"
  xmlns:tr="http://transpect.io"
  xmlns:cx="http://xmlcalabash.com/ns/extensions" 
  xmlns:hub="http://transpect.io/hub"
  xmlns:hub2tei="http://transpect.io/hub2tei" 
  xmlns:css="http://www.w3.org/1996/css"
  name="docx2tei"
  version="1.0">
  
  <p:input port="conf" primary="true">
    <p:documentation xmlns="http://www.w3.org/1999/xhtml">
      <p>See the section on 
        <a href="https://subversion.le-tex.de/common/transpect-demo/content/le-tex/setup-manual/en/out/xhtml/transpect-setup.xhtml#sec-cascade">configuration clades.</a>
      </p>
      <p>The converter works also without clade-based configuration. If you store your content in an arbitrary directory (e.g,
        /my/dir/idml/mycontent.idml), you may put content-specific configuration overrides into /my/dir/css, /my/dir/evolve-hub,
        etc.</p>
    </p:documentation>
    <p:document href="http://this.transpect.io/conf/transpect-conf.xml"/>
  </p:input>
  
  <p:input port="schema" primary="false">
    <p:documentation>Expects the Hub RelaxNG XML schema</p:documentation>
    <p:document href="http://www.le-tex.de/resource/schema/hub/1.1/hub.rng"/>
  </p:input>
  
  <p:output port="hub">
    <p:pipe port="result" step="docx2hub"/>
  </p:output>
   
  <p:output port="paths">
    <p:pipe port="result" step="paths"/>
  </p:output>
  <p:serialization port="paths" indent="true"/>

  <p:output port="tei">
    <p:pipe port="result" step="clean-TEI"/>
  </p:output>
  
<!--  <p:output port="html" sequence="true">
    <p:pipe port="result" step="hub2html"/>
  </p:output>  
 	<p:serialization port="html" omit-xml-declaration="true" indent="false"/>
-->	
  <!--<p:output port="htmlreport">
    <p:pipe port="result" step="htmlreport-remove-srcpath"/>
  </p:output>
  <p:serialization port="htmlreport" omit-xml-declaration="false"/>-->
  
  <p:option name="docxfile" required="true" />
  <p:option name="hub-version" select="'1.2'"/>
  
  <p:option name="clades" select="''"/> 
  
  <p:option name="debug" select="'yes'"/> 
  <p:option name="debug-dir-uri" select="'debug'"/>
  <p:option name="status-dir-uri" select="'status'"/>
  
  <p:option name="progress" required="false" select="'yes'"/>
  <p:option name="check" required="false" select="'yes'"/>
  
  <p:option name="interface-language" required="false" select="'en'"/>
 

  <p:import href="http://xmlcalabash.com/extension/steps/library-1.0.xpl"/>
  
  <p:import href="http://transpect.io/calabash-extensions/unzip-extension/unzip-declaration.xpl"/>
  <p:import href="http://transpect.io/docx2hub/xpl/docx2hub.xpl"/>
  <p:import href="http://transpect.io/hub2html/xpl/hub2html.xpl"/>
  <p:import href="http://transpect.io/cascade/xpl/paths.xpl"/>
  <p:import href="http://transpect.io/xproc-util/simple-progress-msg/xpl/simple-progress-msg.xpl"/>
  <p:import href="http://transpect.io/xproc-util/store-debug/xpl/store-debug.xpl" />
  <p:import href="http://transpect.io/htmlreports/xpl/validate-with-schematron.xpl"/>
  <p:import href="http://transpect.io/htmlreports/xpl/errorPI2svrl.xpl"/>
  <p:import href="http://transpect.io/calabash-extensions/rng-extension/xpl/rng-validate-to-PI.xpl"/>
  <p:import href="http://transpect.io/evolve-hub/xpl/evolve-hub.xpl" />
  <p:import href="http://transpect.io/hub2tei/xpl/hub2tei.xpl"/>
  <p:import href="http://transpect.io/map-style-names/xpl/map-style-names.xpl"/>
  
	
  <p:string-replace name="start-msg-replace" match="file">
    <p:with-option name="replace" select="concat('''', replace($docxfile, '^.+/', ''), '''')"/>
    <p:input port="source">
      <p:inline>
        <c:messages>
          <c:message xml:lang="en">////////// Starting docx2epub conversion of <file/> \\\\\\\\\\</c:message>
          <c:message xml:lang="de">////////// Beginne docx2epub-Konvertierung von <file/> \\\\\\\\\\</c:message>
        </c:messages>
      </p:inline>
    </p:input>    
  </p:string-replace>
  
  <tr:simple-progress-msg name="start-msg" file="docx2epub-start.txt">
    <p:input port="msgs">
      <p:pipe port="result" step="start-msg-replace"/>
    </p:input>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:simple-progress-msg>
  
  <tr:paths name="paths" cx:depends-on="start-msg">
    <p:with-option name="pipeline" select="'docx2epub.xpl'"/>
    <p:with-option name="clades" select="$clades"/>
    <p:with-option name="file" select="$docxfile"/>
    <p:with-option name="interface-language" select="$interface-language"/>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:with-option name="progress" select="$progress"/>
    <p:input port="conf">
      <p:pipe port="conf" step="docx2tei"/>
    </p:input>
    <p:input port="stylesheet">
      <p:document href="http://this.transpect.io/a9s/common/xsl/paths.xsl"/>
    </p:input>
  </tr:paths>

  <p:sink/>
  
  <docx2hub:convert name="docx2hub">
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:with-option name="docx" select="/c:param-set/c:param[@name eq 'file']/@value">
      <p:pipe port="result" step="paths"/>
    </p:with-option>
    <p:with-option name="hub-version" select="$hub-version"/>
    <p:with-option name="srcpaths" select="'yes'"/>
  </docx2hub:convert>
  
  <css:map-styles name="map-styles">
    <p:input port="paths">
      <p:pipe port="result" step="paths"/>
    </p:input>
    <p:with-option name="map-name" select="concat('styles/map-', /c:param-set/c:param[@name eq 'ext']/@value, '.xhtml')">
     <p:pipe port="result" step="paths"/>
    </p:with-option>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </css:map-styles>
  
  
     
   <tr:validate-with-schematron name="sch_flat-hub">
    <p:input port="html-in">
      <p:empty/>
    </p:input>
    <p:input port="parameters">
      <p:pipe port="result" step="paths"/>
    </p:input>
    <p:with-param name="family" select="'flat-hub'"/>
    <p:with-param name="step-name" select="'sch_flat-hub'"/>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:validate-with-schematron>
     
   <hub:evolve-hub name="evolve-hub-dyn" srcpaths="yes">
    <p:input port="paths">
      <p:pipe port="result" step="paths"/> 
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </hub:evolve-hub>
  
  <tr:validate-with-schematron name="sch_evolve">
    <p:input port="html-in">
      <p:empty/>
    </p:input>
    <p:input port="parameters">
      <p:pipe port="result" step="paths"/>    
    </p:input>
    <p:with-param name="family" select="'evolve-hub'"/>
    <p:with-param name="step-name" select="'sch_evolve-hub'"/>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:validate-with-schematron>
  
  <p:sink/>
  
   <hub2tei:hub2tei name="hub2tei">
    <p:input port="source">
      <p:pipe port="result" step="evolve-hub-dyn"/>
    </p:input>
    <p:input port="paths">
      <p:pipe port="result" step="paths"/> 
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </hub2tei:hub2tei>
  
  <p:delete name="clean-TEI" match="@srcpath|@source-dir-uri|@version" cx:depends-on="hub2tei"/>
  
  <!--  
<p:group name="validation">
    <p:output port="report">
      <p:pipe step="errorPI2svrl" port="report"/>
    </p:output>
    <p:output port="result" primary="true">
      <p:pipe step="errorPI2svrl" port="result"/>
    </p:output>
    
    <tr:validate-with-rng-PI name="rng2pi">
      <p:with-option name="debug" select="$debug"/>
      <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
      <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
      <p:input port="schema">
        <p:document href="http://www.le-tex.de/resource/schema/tei-cssa/tei_allPlus-cssa.rng"/>
      </p:input>
      <p:input port="source">
        <p:pipe port="result" step="hub2tei"/>
      </p:input>
    </tr:validate-with-rng-PI>
    
    <tr:store-debug pipeline-step="rngvalid/tei_all-cssa/with-PIs">
      <p:with-option name="active" select="$debug"/>
      <p:with-option name="base-uri" select="$debug-dir-uri"/>
    </tr:store-debug>
    <tr:errorPI2svrl name="errorPI2svrl" severity="error">
      <p:with-option name="debug" select="$debug"/>
      <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
      <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    </tr:errorPI2svrl>
    
    <p:sink name="sink5"/>
    
    <tr:store-debug pipeline-step="rngvalid/tei_all-cssa/report.svrl">
      <p:input port="source">
        <p:pipe step="errorPI2svrl" port="report"/>
      </p:input>
      <p:with-option name="active" select="$debug"/>
      <p:with-option name="base-uri" select="$debug-dir-uri"/>
    </tr:store-debug>
    
    <p:sink name="sink6"/>
    
  </p:group>
  
   <hub2htm:convert name="hub2html">
    <p:input port="source">
      <p:pipe port="result" step="evolve-hub-dyn"/>
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:input port="paths">
      <p:pipe port="result" step="paths"/>
    </p:input>
    <p:with-param name="html-title" select="/c:param-set/c:param[@name eq 'basename']/@value">
      <p:pipe step="paths" port="result"/>
    </p:with-param>
  </hub2htm:convert>
   
  <p:sink/>
  
   <tr:patch-svrl name="patch">
    <p:input port="reports">
      <p:pipe port="report" step="sch_flat-hub"/>
      <p:pipe port="report" step="sch_evolve"/>
      <p:pipe port="report" step="validation"/>
    </p:input>
    <p:input port="source">
      <p:pipe step="hub2html" port="result"/>
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:input port="params">
      <p:pipe port="result" step="paths"/> 
    </p:input>
  </tr:patch-svrl>
  
   <p:delete name="htmlreport-remove-srcpath" match="@srcpath" cx:depends-on="patch"/>
  -->

</p:declare-step>