<?xml version="1.0" encoding="utf-8"?>
<p:declare-step xmlns:p="http://www.w3.org/ns/xproc" 
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:c="http://www.w3.org/ns/xproc-step"  
  xmlns:cx="http://xmlcalabash.com/ns/extensions" 
  xmlns:cxf="http://xmlcalabash.com/ns/extensions/fileutils"
  xmlns:css="http://www.w3.org/1996/css"
  xmlns:dbk="http://docbook.org/ns/docbook"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  xmlns:s="http://purl.oclc.org/dsdl/schematron"
  xmlns:epub="http://transpect.io/epubtools"
  xmlns:hub2htm="http://transpect.io/hub2htm"
  xmlns:tr="http://transpect.io"
  xmlns:jats="http://jats.nlm.nih.gov"
  xmlns:hub="http://transpect.io/hub"
  xmlns:hub2tei="http://transpect.io/hub2tei" 
  version="1.0"
  name="flat2epub"
  type="tr:flat2epub"
  >
    
  <p:input port="source" primary="true"/>
  <p:input port="paths" primary="true" kind="parameter"/>
  <p:input port="reports" sequence="true"/>
  
  <p:option name="check" required="false" select="'yes'"/>
  <p:option name="debug" required="false" select="'no'"/>
  <p:option name="interface-language" required="false" select="'en'"/>
  <p:option name="debug-dir-uri" required="false" select="resolve-uri('debug')"/>
  <p:option name="status-dir-uri" required="false" select="resolve-uri('status')"/>
  
  <p:option name="ub-id" required="false" select="''">
    <p:documentation>If this param is given, a zip package will be created by this name 
    	and including differently named files, the images as well as relative paths for images and CSS files in the created HTML.</p:documentation>
  </p:option>

	
  <p:output port="tei">
  	<p:pipe port="result" step="hub2tei-remove-source-dir-uri"/>
  </p:output>
  <p:serialization port="tei" omit-xml-declaration="false"/>
  
  <p:output port="schematron">
    <p:pipe port="result" step="validation"/>
  </p:output>  
  
  <p:output port="html" sequence="true">
    <p:pipe port="html" step="tei2epub"/>
  </p:output>  
  <p:serialization port="html" omit-xml-declaration="false"/>

  <p:output port="htmlreport" sequence="true">
    <p:pipe port="result" step="htmlreport-remove-srcpath"/>
  </p:output>
  <p:serialization port="htmlreport" omit-xml-declaration="false" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
  
  <p:import href="http://xmlcalabash.com/extension/steps/library-1.0.xpl" />
  <p:import href="http://transpect.io/hub2html/xpl/hub2html.xpl"/>
  <p:import href="http://transpect.io/xproc-util/store-debug/xpl/store-debug.xpl" />
  <p:import href="http://transpect.io/calabash-extensions/rng-extension/xpl/rng-validate-to-PI.xpl"/>
  <p:import href="http://transpect.io/htmlreports/xpl/validate-with-schematron.xpl"/>
  <p:import href="http://transpect.io/cascade/xpl/load-cascaded.xpl"/>
  <p:import href="http://transpect.io/xproc-util/simple-progress-msg/xpl/simple-progress-msg.xpl"/>
  <p:import href="http://transpect.io/htmlreports/xpl/errorPI2svrl.xpl"/>
  <p:import href="http://transpect.io/evolve-hub/xpl/evolve-hub.xpl" />
  <p:import href="http://transpect.io/map-style-names/xpl/map-style-names.xpl" />
  <p:import href="http://transpect.io/hub2tei/xpl/hub2tei.xpl"/>
  <p:import href="http://transpect.io/htmlreports/xpl/check-styles.xpl"/>
	<p:import href="http://transpect.io/xproc-util/xml-model/xpl/prepend-xml-model.xpl"/>
  
  <p:import href="http://this.transpect.io/a9s/common/xpl/tei2epub.xpl"/>

<!--  <p:variable name="source-type" select="/dbk:hub/dbk:info/dbk:keywordset[@role = 'hub']/dbk:keyword[@role = 'source-type']"/>-->

  <p:parameters name="paths">
    <p:input port="parameters">
      <p:pipe port="paths" step="flat2epub"/>
    </p:input>
  </p:parameters>
 
  <css:map-styles name="map-styles">
    <p:input port="source">
      <p:pipe port="source" step="flat2epub"/>
    </p:input>
    <p:input port="paths">
      <p:pipe port="result" step="paths"/>
    </p:input>
    <p:with-option name="map-name" select="concat('styles/map-', /c:param-set/c:param[@name eq 'ext']/@value, '.xhtml')">
      <p:pipe port="result" step="paths"/>
    </p:with-option>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </css:map-styles>

  <tr:validate-with-schematron name="sch_flat-hub">
    <p:input port="html-in">
      <p:empty/>
    </p:input>
    <p:input port="parameters">
      <p:pipe port="paths" step="flat2epub"/>
    </p:input>
    <p:with-param name="family" select="'flat-hub'"/>
    <p:with-param name="step-name" select="'sch_flat-hub'"/>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:validate-with-schematron>

  <hub:evolve-hub name="evolve-hub-dyn" srcpaths="yes">
    <p:input port="paths">
      <p:pipe port="paths" step="flat2epub"/> 
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </hub:evolve-hub>
  
  <tr:validate-with-schematron name="sch_evolve">
    <p:input port="html-in">
      <p:empty/>
    </p:input>
    <p:input port="parameters">
      <p:pipe port="paths" step="flat2epub"/>    
    </p:input>
    <p:with-param name="family" select="'evolve-hub'"/>
    <p:with-param name="step-name" select="'sch_evolve-hub'"/>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:validate-with-schematron>
  
  <p:sink name="sink1"/>
  
  <tr:check-styles name="check-styles">
  	<p:input port="source">
  		<p:pipe port="source" step="flat2epub"/>
  	</p:input>
    <p:input port="html-in">
      <p:empty/>
    </p:input>
    <p:input port="parameters">
      <p:pipe port="result" step="paths"/>
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="cssa" select="'styles/cssa.xml'"/>
    <p:with-option name="differentiate-by-style" select="'true'"/>
    <p:with-option name="step-name" select="'sch_docx_styles'"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </tr:check-styles>
    
  <p:sink name="sink2"/>

  <hub2tei:hub2tei name="hub2tei">
    <p:input port="source">
      <p:pipe port="result" step="evolve-hub-dyn"/>
    </p:input>
    <p:input port="paths">
      <p:pipe port="paths" step="flat2epub"/> 
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
  </hub2tei:hub2tei>
  
  <p:delete match="@srcpath" name="hub2tei-remove-srcpath">
    <p:input port="source">
      <p:pipe port="result" step="hub2tei"/>
    </p:input>
  </p:delete>
	
	<p:delete match="/TEI/teiHeader/profileDesc/textClass" name="hub2tei-remove-keywords">
		<p:input port="source">
			<p:pipe port="result" step="hub2tei-remove-srcpath"/>
		</p:input>
	</p:delete>
<!--	<tr:prepend-xml-model name="tei-with-model">
		<p:input port="models">
			<p:inline>
				<c:models>
					<c:model href="http://www.le-tex.de/resource/schema/tei/tei_allPlus.rng" type="application/xml"
						schematypens="http://relaxng.org/ns/structure/1.0" />
					<c:model href="http://www.le-tex.de/resource/schema/tei/tei_allPlus.rng" type="application/xml"
						schematypens="http://purl.oclc.org/dsdl/schematron" />
				</c:models>
			</p:inline>
		</p:input>
	</tr:prepend-xml-model>-->
   
	<p:delete match="@source-dir-uri"  name="hub2tei-remove-source-dir-uri">
		<p:input port="source">
			<p:pipe port="result" step="hub2tei-remove-keywords"/>
		</p:input>
	</p:delete>
  
  <tr:store-debug pipeline-step="difftest/out">
    <p:with-option name="active" select="$debug"/>
    <p:with-option name="base-uri" select="$debug-dir-uri"/>
  </tr:store-debug>
  
  <p:sink name="sink3"/>

  <p:group name="validation">
    <p:output port="report"><p:pipe step="errorPI2svrl" port="report"/></p:output>
    <p:output port="result" primary="true"><p:pipe step="errorPI2svrl" port="result"/></p:output>
    
    <tr:validate-with-rng-PI name="rng2pi">
      <p:with-option name="debug" select="$debug"/>
      <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
      <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
      <p:input port="schema">
        <p:document href="http://www.le-tex.de/resource/schema/tei-cssa/tei_allPlus-cssa.rng"/>
      </p:input>
      <p:input port="source">
        <p:pipe port="result" step="hub2tei"/>
      </p:input>
    </tr:validate-with-rng-PI>
    
    <tr:store-debug pipeline-step="rngvalid/tei_all-cssa/with-PIs">
      <p:with-option name="active" select="$debug"/>
      <p:with-option name="base-uri" select="$debug-dir-uri"/>
    </tr:store-debug>
    <tr:errorPI2svrl name="errorPI2svrl" severity="error">
      <p:with-option name="debug" select="$debug"/>
      <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
      <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    </tr:errorPI2svrl>
    
    <p:sink name="sink5"/>
    
    <tr:store-debug pipeline-step="rngvalid/tei_all-cssa/report.svrl">
      <p:input port="source">
        <p:pipe step="errorPI2svrl" port="report"/>
      </p:input>
      <p:with-option name="active" select="$debug"/>
      <p:with-option name="base-uri" select="$debug-dir-uri"/>
    </tr:store-debug>
    
    <p:sink name="sink6"/>
    
  </p:group>

  <tr:tei2epub name="tei2epub">
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:with-option name="interface-language" select="$interface-language"/>
  	<p:with-option name="ub-id" select="$ub-id"/>
    <p:input port="paths">
      <p:pipe port="paths" step="flat2epub"/> 
    </p:input>
    <p:input port="source">
      <p:pipe port="result" step="hub2tei"/>
    </p:input>
  </tr:tei2epub>

  <p:choose name="select-which-hub2html">
    <p:documentation>
      Here will be chosen which hub is used for creating the HTML for the error report. Default is the flat hub. If the evolved hub shall be used,
      add to you config file &gt;param name="which-htmlreport" value="evolve-hub"/>.
      Be aware that using the evolved hub can lead to problems with no longer existing srcpaths (discarded empty paras, or other elements and merged paras as well).
    </p:documentation>
    <p:variable name="which-html" select="/c:param-set/c:param[@name eq 'which-htmlreport']/@value">
      <p:pipe step="paths" port="result"/>
    </p:variable>
    <p:when test="$which-html = 'evolve-hub'">
      <p:identity>
        <p:input port="source">
          <p:pipe port="result" step="evolve-hub-dyn"/>
        </p:input>
      </p:identity>
    </p:when>
    <p:when test="$which-html = 'tei2epub'">
      <p:identity>
        <p:input port="source">
          <p:pipe port="html" step="tei2epub"/>
        </p:input>
      </p:identity>
    </p:when>
    <p:otherwise>
      <p:identity>
        <p:input port="source">
          <p:pipe port="result" step="map-styles"/>
        </p:input>
      </p:identity>
    </p:otherwise>
  </p:choose>
  
  <hub2htm:convert name="hub2html" cx:depends-on="select-which-hub2html">
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:input port="paths">
      <p:pipe port="paths" step="flat2epub"/>
    </p:input>
    <p:with-param name="html-title" select="/c:param-set/c:param[@name eq 'basename']/@value">
      <p:pipe step="paths" port="result"/>
    </p:with-param>
  </hub2htm:convert>
   
  <p:sink/>
  
  <tr:patch-svrl name="patch">
    <p:input port="reports">
      <p:pipe port="reports" step="flat2epub"/>
      <p:pipe port="report" step="sch_flat-hub"/>
      <p:pipe port="report" step="check-styles"/>
      <p:pipe port="report" step="validation"/>
      <p:pipe port="report" step="sch_evolve"/>
      <p:pipe port="report" step="tei2epub"/>
    	<p:pipe port="report" step="evolve-hub-dyn"/>
    </p:input>
    <p:input port="source">
      <p:pipe step="hub2html" port="result"/>
    </p:input>
    <p:with-option name="debug" select="$debug"/>
    <p:with-option name="debug-dir-uri" select="$debug-dir-uri"/>
    <p:with-option name="status-dir-uri" select="$status-dir-uri"/>
    <p:with-option name="report-title" select="/c:param-set/c:param[@name eq 'basename']/@value">
      <p:pipe port="result" step="paths"/>
    </p:with-option>
  	<p:with-option name="discard-empty-schematron-outputs" select="'yes'"/>
    <p:input port="params">
      <p:pipe port="paths" step="flat2epub"/> 
    </p:input>
  </tr:patch-svrl>
  
  <p:delete name="htmlreport-remove-srcpath" match="@srcpath" cx:depends-on="patch"/>
  
  <p:sink name="sink9"/>
  
  <tr:store-debug pipeline-step="schematron/check-styles" extension="xml">
    <p:input port="source">
      <p:pipe port="result" step="check-styles"/>
    </p:input>
    <p:with-option name="active" select="$debug"/>
    <p:with-option name="base-uri" select="$debug-dir-uri"/>
  </tr:store-debug>
  
  <p:sink name="sink10"/>
  
</p:declare-step>
